////////////////////////////////////////////////////////////////////////////
/*	MnuPak by Cdric Vidal vers 0b5																				*/
/*	release date:	4 June 2000																							*/
/*	To compile, you will need TIGCC 		by Xavier VASSOR									*/
/*														TIGCCLIB 	by Zeljko Juric										*/
/*	both can be found on www.ticalc.org or www.ti-fr.fr.st/								*/
/*	please, respect the terms of the GNU GENERAL PUBLIC LICENSE						*/
////////////////////////////////////////////////////////////////////////////

#define RETURN_VALUE mnu_res

#include <nostub.h>
#include <all.h>

int _ti89;

char comment[25] = "MnuPack by CFu vers 0b5";

/* definition of a data node for holding menus information */
struct mnu {
//   char	title[20];
   ESI	list;
   int	line_abs;		//	ligne absolue
   int	line_rel;		//	ligne relative
   int	line_pos;		//	= line_abs - line_rel
   int	line_nb;
   int	line_shw;		//	nb de lignes  afficher
   int	id;
   SCR_RECT rect;
   struct mnu *next;
};

/* head points to first node in list, end points to last node in list */
/* initialise both to NULL, meaning no nodes in list yet */
struct mnu *head = (struct mnu *) NULL;
struct mnu *end = (struct mnu *) NULL;

int test_i = 0;

int max_int(int a, int b)	{	return ((a < b)?(b):(a));	}
int min_int(int a, int b)	{	return ((a < b)?(a):(b));	}

void drawbarre( struct mnu *ptr )
{
	SCR_RECT barre_rect = {
		ptr->rect.xy.x0 + 1,
		ptr->rect.xy.y0 + (ptr->line_rel)*9 + 1,
		ptr->rect.xy.x1 - 1,
		ptr->rect.xy.y0 + (ptr->line_rel+1)*9
	};
	
	ScrRectFill (&barre_rect, ScrRect, A_XOR);
}

void movebarre( struct mnu *ptr, int newline )
{
	drawbarre(ptr);		// efface la ligne prcdente
	ptr->line_abs = newline; ptr->line_rel = newline - ptr->line_pos;
	drawbarre(ptr);		// affiche la ligne courante
}

SYM_ENTRY *get_ptr(char *str, int i)
{
	char name[18];
	name[0] = 0;
	return SymFindPtr(strcpy(name+1, str+i)+strlen(str+i), 0);
}

ESI GetMnuHandlePtr(char * mnu_name)
{
	// variables
  SYM_ENTRY*	SymPtr;
  int 				size;
  void*				HandlePtr;
  ESI					MnuHandlePtr;

	// on rcupre le pointeur vers le symbol
	SymPtr = get_ptr(mnu_name, 0);
	//SymPtr = SymFindPtr (GetSymstrArg (argptr), 0);
	if (SymPtr != NULL)
	{
		// on rcupre le pointeur vers le dbut du handle
		HandlePtr = HeapDeref (SymPtr->handle);

		// on rcupre la taille du handle
		size = *(unsigned char*)(HandlePtr + 1);

		// on en dduit le pointeur vers la fin du handle
		// (necssaire pour le parcours dans le bon sens de la liste)
		MnuHandlePtr = HandlePtr + size + 1;

		// on rcupre le type du handle
		// et si c'est bien une liste, on renvoie le pointeur
		if (GetArgType(MnuHandlePtr) == LIST_TAG) return MnuHandlePtr;
	}
	return NULL;
}

char * GetMnuTitle(mnu_id)
{
	char mnu_name[8];
  ESI	item;
	int	argtype;

	sprintf(mnu_name, "mnu_%04d",mnu_id);

	if ((item = GetMnuHandlePtr(mnu_name)) != NULL) {
		if ((argtype	=	GetArgType(item)) == LIST_TAG) {
			item--;
			if ((argtype	=	GetArgType(item)) == STR_TAG) return GetStrnArg(item);
		}
	}
	return NULL;
}

int GetMnuDimSub( int level, ESI argptr, int *maxwidth, int *line_nb )
{
	int	argtype;
	int mnu_id;
	char * mnu_title;
	int width;
	argtype	=	GetArgType(argptr);

	switch(argtype)
	{
		case END_TAG:		// on monte d'un niveau
			level--;
//			printf("END_TAG level=%d ptr=%lx\n",level,argptr);
			argptr--;
			if (level > 0) GetMnuDimSub(level, argptr, maxwidth, line_nb);
			else
			{
//				printf("level=%d *line_nb=%d *maxwidth=%d\n", level, *line_nb, *maxwidth);ngetchx();
//				*maxwidth = (*maxwidth+2)*6+3;
//				*line_nb = (*line_nb-1)*9+1;
				return;
			}
			break;

		case LIST_TAG:	// on baisse d'un niveau
//			printf("LIST_TAG level=%d ptr=%lx\n",level,argptr);
			argptr--;
			GetMnuDimSub(level + 1, argptr, maxwidth, line_nb);
			break;

		case STR_TAG:				// on reste au mme niveau
			width = strlen( GetStrnArg(argptr) );
//			printf("  %s\n",GetStrnArg(argptr));
//			printf("level=%d width=%d *maxwidth=%d\n", level, width, *maxwidth);ngetchx();
			if (*maxwidth < width) (*maxwidth = width); (*line_nb)++;
			GetMnuDimSub(level, argptr, maxwidth, line_nb);
			break;

		case POSINT_TAG:				// on reste au mme niveau
			mnu_id = GetIntArg(argptr);
			if ((mnu_title = GetMnuTitle(mnu_id)) != NULL) {
				width = strlen( mnu_title );
//				printf("level=%d width=%d *maxwidth=%d\n", level, width, *maxwidth);ngetchx();
				if (*maxwidth < width) (*maxwidth = width); (*line_nb)++;
				GetMnuDimSub(level, argptr, maxwidth, line_nb);
			}
			else GetMnuDimSub(level, argptr, maxwidth, line_nb);
			break;

		default:				// on reste au mme niveau
			SkipArg(argptr);
			GetMnuDimSub(level, argptr, maxwidth, line_nb);
			break;
	}
}

GetMnuDim( struct mnu *ptr, int *width, int *line_nb ) {
	*width = 0;
	*line_nb = 0;
	GetMnuDimSub(0, ptr->list, width, line_nb);
}

/* this initialises a node, allocates memory for the node, and returns   */
/* a pointer to the new node. Must pass it the node details, name and id */
struct mnu * InitMnu(ESI HandlePtr, int mnu_id)
{
	struct mnu *ptr;
	int mnu_width;
	int mnu_height;
	int line_nb;
	
	ptr = (struct mnu *) calloc( 1, sizeof(struct mnu ) );
	if( ptr == NULL )                       /* error allocating node?      */
	{
		return (struct mnu *) NULL;        /* then return NULL, else      */
	}
	else {                                  /* allocated node successfully */
//		strcpy( ptr->title, title );          /* fill in name details        */
		ptr->list = HandlePtr;
//		ptr->rect.xy = {30, 10, 80, 70};
		GetMnuDim(ptr, &mnu_width, &line_nb);		// le mnu_width renvoy est en fait le
																						// nb de charactres en largeur
		mnu_width = (mnu_width+2)*6+3;
		mnu_height = (min_int(--line_nb,8))*9+1;
		
//		printf("mnu_width=%d\n",mnu_width);ngetchx();
		if (end == NULL)
		{
			ptr->rect.xy.x0 = 10;
			ptr->rect.xy.y0 = 12;
			ptr->rect.xy.x1 = 10 + mnu_width;
			ptr->rect.xy.y1 = 12 + mnu_height;
		}
		else
		{
			if (end->rect.xy.x0 < ScrRect->xy.x1 - end->rect.xy.x1)
			{
				ptr->rect.xy.x0 = ScrRect->xy.x1 - max_int( mnu_width, ScrRect->xy.x1 - end->rect.xy.x1) - 5;
			}
			else
			{
				ptr->rect.xy.x0 = end->rect.xy.x0 - min_int( mnu_width - 5, end->rect.xy.x0);
			}
			
			ptr->rect.xy.y0 = ScrRect->xy.y1 - max_int(ScrRect->xy.y1 - (end->rect.xy.y0 + (end->line_rel) * 9), mnu_height + 1);
			ptr->rect.xy.x1 = ptr->rect.xy.x0 + mnu_width;
			ptr->rect.xy.y1 = ptr->rect.xy.y0 + mnu_height;
		}
		ptr->line_abs = 0;
		ptr->line_rel = 0;
		ptr->line_pos = 0;
		ptr->line_nb = line_nb;
		ptr->line_shw = 8;
		ptr->id = mnu_id;
		
		return ptr;
	}
}

/* this adds a mnu to the end of the list.                               */
void addmnu( struct mnu *new )
{
	if(head == NULL)
	{
		head = new;
		end = new;
		head->next = NULL;
		return;
	}
	end->next = new;        /* link in the new node to the end of the list */
	new->next = NULL;       /* set next field to signify the end of list   */
	end = new;              /* adjust end to point to the last node        */
}


void deletemnu( struct mnu *ptr )
{
   struct mnu *temp, *prev;
   temp = ptr;    /* mnu to be deleted */
   prev = head;   /* start of the list, will cycle to mnu before temp    */

   if( temp == prev ) {                    /* are we deleting first node  */
       head = head->next;                  /* moves head to next node     */
       if( end == temp )                   /* is it end, only one node?   */
          end = end->next;                 /* adjust end as well          */
       free( temp );                       /* free space occupied by node */
   }
   else {                                  /* if not the first node, then */
       while( prev->next != temp ) {       /* move prev to the node before*/
           prev = prev->next;              /* the one to be deleted       */
       }
       prev->next = temp->next;            /* link previous node to next  */
       if( end == temp )                   /* if this was the end node,   */
           end = prev;                     /* then reset the end pointer  */
       free( temp );                       /* free space occupied by node */
   }
}

/* this deletes all nodes from the place specified by ptr                 */
/* if you pass it head, it will free up entire list                       */
void deletemnulist( struct mnu *ptr )
{
   struct mnu *temp;

   if( head == NULL ) return;   /* dont try to delete an empty list       */

   if( ptr == head ) {      /* if we are deleting the entire list         */
       head = NULL;         /* then reset head and end to signify empty   */
       end = NULL;          /* list                                       */
   }
   else {
       temp = head;          /* if its not the entire list, readjust end  */
       while( temp->next != ptr )         /* locate previous node to ptr  */
           temp = temp->next;
       end = temp;                        /* set end to node before ptr   */
   }

   while( ptr != NULL ) {   /* whilst there are still nodes to delete     */
      temp = ptr->next;     /* record address of next node                */
      free( ptr );          /* free this node                             */
      ptr = temp;           /* point to next node to be deleted           */
   }
}

void cleanup()
{
	// destruction des handles de menu
	deletemnulist(head);
}

void showlistsub(int level, ESI argptr, int from, int to, int x, int y)
{
	int	argtype;
	int mnu_id;
	char * mnu_title;
	argtype	=	GetArgType(argptr);
	if (to <= 0) return;

	switch(argtype)
	{
		case END_TAG:		// on monte d'un niveau
			level--;
//			printf("END_TAG level=%d ptr=%lx\n",level,argptr);
			argptr--;
			if (level > 0) showlistsub(level, argptr, from, to, x, y);
			else return;
			break;

		case LIST_TAG:	// on baisse d'un niveau
//			printf("LIST_TAG level=%d ptr=%lx\n",level,argptr);
			argptr--;
			showlistsub(level + 1, argptr, from, to, x, y);
			break;

		case STR_TAG:				// on reste au mme niveau
			if (from>0) {
				SkipArg(argptr);
				showlistsub(level, argptr, from-1, to, x, y);
			}
			else
			{
				DrawStr(x + 2, y + 2, GetStrnArg(argptr), A_REPLACE);
				showlistsub(level, argptr, from, to-1, x, y+9);
			}
			break;

		case POSINT_TAG:				// on reste au mme niveau
			if (from>0) {
				SkipArg(argptr);
				showlistsub(level, argptr, from-1, to, x, y);
			}
			else
			{
				mnu_id = GetIntArg(argptr);
				if ((mnu_title = GetMnuTitle(mnu_id)) != NULL)
						(printf_xy(x + 2, y + 2, "%s >",mnu_title));
					else printf_xy(x + 2, y + 2, "!! err !!");
//				printf("%d\n",mnu_id);
//				printf("%d > level=%d ptr=%lx\n",mnu_id,level,argptr);
				showlistsub(level, argptr, from, to-1, x, y+9);
			}
			break;

		default:				// on reste au mme niveau
			printf_xy(x + 2, y + 2, "err:type unknown");
			SkipArg(argptr);
			showlistsub(level, argptr, from-1, to-1, x, y+9);
			break;
	}
}

void showlist(struct mnu *ptr)
{
	showlistsub(0, ptr->list, ptr->line_pos + 1, ptr->line_shw, ptr->rect.xy.x0, ptr->rect.xy.y0);
}

void showmnu( struct mnu *ptr )
{
	ScrRectFill (&(ptr->rect), ScrRect, A_REVERSE);
	DrawClipRect(ScrToWin(&(ptr->rect)), ScrRect, A_NORMAL);
	showlist(ptr);
}

void showmnus(struct mnu *ptr)
{
	while( ptr != end ) {   /* whilst there are still nodes to delete     */
		showmnu( ptr );          /* free this node                             */
		drawbarre(ptr);
		ptr = ptr->next;
	}
	showmnu(end);
	drawbarre(end);
}

BOOL loadmnu(int mnu_id)
{
	char mnu_name[8];
  ESI	MnuHandlePtr;
	struct mnu *newmnu;

	sprintf(mnu_name, "mnu_%04d",mnu_id);

	if ((MnuHandlePtr = GetMnuHandlePtr(mnu_name)) != NULL)
	{
		if ((newmnu = InitMnu(MnuHandlePtr, mnu_id)) != NULL)
		{
			addmnu(newmnu);
//			printmnu(end);
			showmnu(end);
			drawbarre(end);
			return 1;
		}
	}// else print(" error: menu not found");
	return 0;
}

void selectitem(struct mnu *ptr, int start)
{
	int argtype;
	ESI item;
	int nb;
	
	item = ptr->list;
	nb = ptr->line_abs + start;
	
	if (GetArgType(item--) == LIST_TAG)
	{
		while(((nb--)> 0)&&((argtype = GetArgType(item)) != END_TAG))
		{
			SkipArg	(item);
		}
//		if (GetArgType(item) == STR_TAG) print(GetStrnArg(item));
		if (GetArgType(item) == POSINT_TAG) loadmnu(GetIntArg(item));
	}
}

void PushResult()
{
//	if AMS_1xx
//	{
		struct mnu *ptr;
		push_END_TAG ();
		ptr = head;
		while( ptr != end ) {
			push_END_TAG ();
			push_longint (ptr->line_abs + 1);
			push_longint (ptr->id);
			push_LIST_TAG ();
			
			ptr = ptr->next;
		}
		
		push_END_TAG ();
		push_longint (end->line_abs + 1);
		push_longint (end->id);
		push_LIST_TAG ();
		
		push_LIST_TAG ();
//	}
}
////////////////////////////////////////////////////////////////////////////
//																																				//
//																																				//
//																																				//
//																																				//
////////////////////////////////////////////////////////////////////////////

void _main(void)
{
	// screen
	LCD_BUFFER	scr_buffer;
	LCD_BUFFER	vrs_buffer;		// virtual screen

	// arguments
  ESI argptr = top_estack;
  int argtype;

  // mnu
  int mnu_id;

  int key;

	LCD_save (&scr_buffer);

	ST_helpMsg (comment);

	// on rcupre le paramtre
	if ((argtype = GetArgType(argptr)) == POSINT_TAG)
	{
		mnu_id = GetIntArg(argptr);
		if (loadmnu(mnu_id)==1)
		{
			// main loop
			while (((key=ngetchx())!=264)&&(key!=13))
			{
				if ((key == KEY_DOWN)&&(end->line_abs < (end->line_nb-1)))		// down key
				{
					if (end->line_rel < (end->line_shw-1)) movebarre(end, end->line_abs + 1);
					else
					{
						(end->line_abs)++; (end->line_pos)++;
						showmnu(end);
						drawbarre(end);
					}
					
				}
				
				else if ((key == KEY_UP)&&(end->line_abs > 0))		// Up
				{
					if (end->line_rel > 0) movebarre(end, end->line_abs - 1);
					else
					{
						(end->line_abs)--; (end->line_pos)--;
						showmnu(end);
						drawbarre(end);
					}
				}
				
				else if (key == KEY_RIGHT)		// Up
				{
					selectitem(end, 1);
				}
				
				// touches numriques
				else if ((48 < key)&&(key-48 <= end->line_nb))
				{
					if (key-49 < (end->line_shw)) 
					{
						movebarre(end, key-49);
						selectitem(end, 1);
					}
				}
				else if ((key == 48)||(key == 338))
				{
					if (end != head)
					{
						deletemnu(end);
						memmove(&vrs_buffer, &scr_buffer, LCD_SIZE);
						PortSet(&vrs_buffer, 239, 127);
						showmnus(head);
						PortRestore();
						LCD_restore (&vrs_buffer);
					}
				}
			}
			
			// on renvoie le rsultat ??
			if (key == 13) PushResult();
			else
			{
				push_END_TAG ();
				push_LIST_TAG ();
			}
		}
	}

	cleanup();

	// restore screen
	LCD_restore (&scr_buffer);
}
